package cokr.xit.ens.modules.common.ctgy.sys.mng.domain.repository;

import cokr.xit.ens.core.utils.CmmnUtil;
import cokr.xit.ens.modules.common.ctgy.sys.mng.domain.TmpltMng;
import cokr.xit.ens.modules.common.ctgy.sys.mng.model.TmpltMngDTO;
import cokr.xit.ens.modules.common.ctgy.sys.mng.model.TmpltMngSearchDTO;
import com.querydsl.core.BooleanBuilder;
import com.querydsl.core.types.Projections;
import com.querydsl.core.types.QBean;
import com.querydsl.jpa.impl.JPAQueryFactory;
import lombok.RequiredArgsConstructor;

import java.util.List;
import java.util.Optional;

import static cokr.xit.ens.modules.common.ctgy.sys.mng.domain.QOrgMng.orgMng;
import static cokr.xit.ens.modules.common.ctgy.sys.mng.domain.QTmpltMng.tmpltMng;

@RequiredArgsConstructor
public class TmpltMngRepositoryImpl implements TmpltMngRepositoryCustom {

    private final JPAQueryFactory query;

    @Override
    public List<TmpltMng> findAllFetchBySearchDTO(TmpltMngSearchDTO searchDTO) {
        return query.selectFrom(tmpltMng)
                .innerJoin(tmpltMng.orgMng, orgMng)
                .fetchJoin()
                .where(eqSearchDTO(searchDTO))
                .fetch();
    }

    @Override
    public Optional<TmpltMng> findFetchByOrgCdAndTmpltCd(String orgCd, String tmpltCd) {
        return Optional.ofNullable(query.selectFrom(tmpltMng)
                .innerJoin(tmpltMng.orgMng, orgMng)
                .fetchJoin()
                .where(tmpltMng.orgMng.orgCd.eq(orgCd)
                        .and(tmpltMng.tmpltCd.eq(tmpltCd)))
                .fetchOne());
    }

    @Override
    public Optional<TmpltMngDTO> findDtoByOrgCdAndTmpltCd(String orgCd, String tmpltCd) {
        return Optional.ofNullable(query.select(mappedDto())
                .from(tmpltMng)
                .where(tmpltMng.orgMng.orgCd.eq(orgCd)
                        .and(tmpltMng.tmpltCd.eq(tmpltCd)))
                .fetchOne());
    }

    @Override
    public List<TmpltMngDTO> findAllDtoBySearchDTO(TmpltMngSearchDTO searchDTO) {
        return query.select(mappedDto())
                .from(tmpltMng)
                .innerJoin(tmpltMng.orgMng, orgMng)
                .where(eqSearchDTO(searchDTO))
                .fetch();
    }

    private QBean<TmpltMngDTO> mappedDto() {
        return Projections.fields(TmpltMngDTO.class
                , tmpltMng.dtype
                , tmpltMng.orgMng.orgCd
                , tmpltMng.orgMng.orgNm
                , tmpltMng.tmpltCd
                , tmpltMng.title
                , tmpltMng.message
                , tmpltMng.useYn
        );
    }

    private BooleanBuilder eqSearchDTO(TmpltMngSearchDTO searchDTO) {
        BooleanBuilder builder = new BooleanBuilder();

        if (!CmmnUtil.isEmpty(searchDTO.getSchOrgCd()))
            builder.and(tmpltMng.orgMng.orgCd.eq(searchDTO.getSchOrgCd()));

        if (!CmmnUtil.isEmpty(searchDTO.getSchTmpltCd()))
            builder.and(tmpltMng.tmpltCd.eq(searchDTO.getSchTmpltCd()));

        if (!CmmnUtil.isEmpty(searchDTO.getSchTitle()))
            builder.and(tmpltMng.title.like(searchDTO.getSchTitle() + "%"));


        return builder;
    }

    @Override
    public Optional<TmpltMng> findFetchByOrgCdAndTmpltCdAndUseYn(String orgCd, String tmpltCd, String useYn) {
        return Optional.ofNullable(
                query.selectFrom(tmpltMng)
                        .innerJoin(tmpltMng.orgMng, orgMng)
                        .fetchJoin()
                        .where(
                                tmpltMng.orgMng.orgCd.eq(orgCd)
                                        .and(tmpltMng.tmpltCd.eq(tmpltCd))
                                        .and(tmpltMng.useYn.eq(useYn))
                        )
                        .fetchOne());
    }
}
